<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import BlogCard from '../../components/customers/blog-card.vue';
import { CONTENT_TYPES } from '../../common/content-types';
import { getClient } from '../../plugins/contentful';
import {
  Copy,
  CopyMedia,
  NextStep,
  FeaturedReports,
} from '../../components/common/index.vue';
import {
  AccordionFeatureList,
  AnalystsContacts,
  AnalystsHero,
  MarketResearch,
  Review,
} from '../../components/analysts/index.vue';
import { TopicsHeader } from '../../components/topics/index.vue';
import { getPageMetadata } from '../../common/meta';

export default Vue.extend({
  name: 'Analysts',
  components: {
    AccordionFeatureList,
    AnalystsContacts,
    AnalystsHero,
    BlogCard,
    Copy,
    CopyMedia,
    FeaturedReports,
    MarketResearch,
    TopicsHeader,
    NextStep,
    Review,
  },
  nuxtI18n: false,
  async asyncData({ error }: any) {
    try {
      const { items } = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'analysts',
        include: 10,
      });

      const data = items[0].fields.pageContent;
      const metadata = items[0].fields.seoMetadata[0].fields;
      //  Data Mapping:

      const [hero, marketResearch, accordion, contacts] = data;
      const components = [] as any[];

      // Hero

      components.push({
        name: 'analysts-hero',
        data: {
          title: hero.fields.title,
          text: hero.fields.description,
          image: {
            url: hero.fields.backgroundImage.fields.file.url,
            alt: 'Infinity logo',
          },
        },
      });

      //  Market research
      components.push({
        name: 'market-research',
        data: {
          title: marketResearch.fields.header,
          metadata: {
            id_tag: 'market-research',
          },
          reports: marketResearch.fields.card.map((card: any) => ({
            name: card.fields.title,
            logo: card.fields.image.fields.file.url,
            logo_alt: card.fields.image.fields.title,
            cta_url: card.fields.cardLink,
            cta_data_ga_location: 'reports',
            cta_data_ga_name: card.fields.cardLinkDataGaName,
          })),
        },
      });

      // accordion

      components.push({
        name: 'accordion-feature-list',
        data: accordion.fields.data,
      });

      //  Contacts

      components.push({
        name: 'analysts-contacts',
        data: {
          title: contacts.fields.header,
          cards: contacts.fields.card.map((card: any) => ({
            ...card.fields.customFields,
          })),
        },
      });

      const analysts = {
        ...metadata,
        components,
      };

      return { analysts };
    } catch (e) {
      error({ statusCode: 404 });
      return {};
    }
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).analysts, this.$route.path);
  },
  mounted() {
    console.log(this.analysts);
  },
});
</script>
<template>
  <div class="analysts-wrapper">
    <component
      :is="component.name"
      v-for="component in analysts.components"
      :key="component.name"
      :data="component.data"
    />
    <SlpContainer variant="gradient">
      <NextStep :variant="1" />
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.analysts-wrapper {
  overflow: hidden;
}
</style>
